/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg.grpc;

import com.google.gson.Gson;
import com.google.gson.stream.JsonReader;
import io.grpc.ManagedChannel;
import io.grpc.ManagedChannelBuilder;
import java.io.*;
import java.util.Map;
import java.nio.charset.StandardCharsets;

/**
 *
 * @author omozegieaziegbe
 */
public class GrpcClient {

    public static void main(String[] args) {
        // Load the service configuration from the JSON file using Gson
        Gson gson = new Gson();
        Map<String, ?> serviceConfig;

        serviceConfig = gson.fromJson(new JsonReader(new InputStreamReader(GrpcClient.class.getClassLoader()
                .getResourceAsStream("service_config.json"), StandardCharsets.UTF_8)), Map.class);

        // Build the channel with retry policy
        ManagedChannel channel = ManagedChannelBuilder.forAddress("localhost", 50051)
                .usePlaintext()
                .disableServiceConfigLookUp()
                .defaultServiceConfig(serviceConfig)
                .enableRetry()
                .build();

        UserServiceGrpc.UserServiceBlockingStub stub = UserServiceGrpc.newBlockingStub(channel);

        GetUserRequest request = GetUserRequest.newBuilder()
                .setUserId("12345")
                .build();

        try {
            GetUserResponse response = stub.getUser(request);
            System.out.println("User: " + response.getName() + ", Email: " + response.getEmail());
        } catch (Exception e) {
        } finally {
            channel.shutdown();
        }
    }
}
